bash - shell判断文件是否存在




如何判断Bash中是否存在常规文件? (12)

我使用以下脚本来查看文件是否存在:

#!/bin/bash

FILE=$1     
if [ -f $FILE ]; then
   echo "File $FILE exists."
else
   echo "File $FILE does not exist."
fi

如果我只想检查文件是否存在,使用的语法是什么?

#!/bin/bash

FILE=$1     
if [ $FILE does not exist ]; then
   echo "File $FILE does not exist."
fi

test命令( [这里]有一个“not”逻辑运算符,它是感叹号(类似于许多其他语言)。 试试这个:

if [ ! -f /tmp/foo.txt ]; then
    echo "File not found!"
fi


你可以用“!”来否定表达式:

#!/bin/bash
FILE=$1

if [ ! -f "$FILE" ]
then
    echo "File $FILE does not exist"
fi

相关的手册页是man test或者等同于man [ - 或help testhelp [用于内置bash命令。


你可以这样做:

[[ ! -f "$FILE" ]] && echo "File doesn't exist"

要么

if [[ ! -f "$FILE" ]]; then
    echo "File doesn't exist"
fi

如果要同时检查文件和文件夹,请使用-e选项而不是-f-e对常规文件,目录,套接字,字符特殊文件,块特殊文件等返回true。


[ -f "$file" ]

[命令对存储在$file的路径执行stat() (不是lstat() )系统调用,如果系统调用成功,则返回truestat()返回的文件类型为“regular”。

因此,如果[ -f "$file" ]返回true,您可以告诉该文件确实存在,并且是一个常规文件或符号链接最终解析为常规文件(或者至少是在stat() )。

但是,如果它返回false (或者如果[ ! -f "$file" ]! [ -f "$file" ]返回true),则有许多不同的可能性:

  • 该文件不存在
  • 该文件存在但不是常规文件
  • 该文件存在,但您没有父目录的搜索权限
  • 该文件存在,但访问它的路径太长
  • 该文件是常规文件的符号链接,但您没有对符号链接解析中涉及的某些目录的搜索权限。
  • ... stat()系统调用可能失败的任何其他原因。

简而言之,它应该是:

if [ -f "$file" ]; then
  printf '"%s" is a path to a regular file or symlink to regular file\n' "$file"
elif [ -e "$file" ]; then
  printf '"%s" exists but is not a regular file\n' "$file"
elif [ -L "$file" ]; then
  printf '"%s" exists, is a symlink but I cannot tell if it eventually resolves to an actual file, regular or not\n' "$file"
else
  printf 'I cannot tell if "%s" exists, let alone whether it is a regular file or not\n' "$file"
fi

要确定该文件不存在,我们需要使用stat()系统调用返回错误代码ENOENTENOTDIR告诉我们其中一个路径组件不是目录是我们可以告诉的另一种情况该路径不存在该文件)。 不幸的是[命令不让我们知道。 无论错误代码是ENOENT,EACCESS(权限被拒绝),ENAMETOOLONG还是其他任何内容,它都将返回false。

[ -e "$file" ]测试也可以使用ls -Ld -- "$file" > /dev/null 。 在这种情况下, ls将告诉您stat()失败的原因,尽管信息不能以编程方式轻松使用:

$ file=/var/spool/cron/crontabs/root
$ if [ ! -e "$file" ]; then echo does not exist; fi
does not exist
$ if ! ls -Ld -- "$file" > /dev/null; then echo stat failed; fi
ls: cannot access '/var/spool/cron/crontabs/root': Permission denied
stat failed

至少ls告诉我这不是因为文件不存在而失败了。 这是因为它无法判断文件是否存在。 [命令只是忽略了问题。

使用zsh shell,您可以在失败的[ command]之后使用$ERRNO特殊变量查询错误代码,并使用zsh/system模块中的$errnos special数组解码该数字:

zmodload zsh/system
ERRNO=0
if [ ! -f "$file" ]; then
  err=$ERRNO
  case $errnos[err] in
    ("") echo exists, not a regular file;;
    (ENOENT|ENOTDIR)
       if [ -L "$file" ]; then
         echo broken link
       else
         echo does not exist
       fi;;
    (*) echo "can't tell"; syserror "$err"
  esac
fi

(注意当使用最新版本的gcc构建时,某些版本的zsh会损坏$errnos支持 )。


您应该小心为不带引号的变量运行test ,因为它可能会产生意外的结果:

$ [ -f ]
$ echo $?
0
$ [ -f "" ]
$ echo $?
1

建议通常是让测试变量用双引号括起来:

#!/bin/sh
FILE=$1

if [ ! -f "$FILE" ]
then
   echo "File $FILE does not exist."
fi

最简单的方法

FILE=$1
[ ! -e "${FILE}" ] && echo "does not exist" || echo "exists"

有三种不同的方法可以做到这一点:

  1. 用bash否定退出状态(没有其他答案说过这个):

    if ! [ -e "$file" ]; then
        echo "file does not exist"
    fi
    

    要么:

    ! [ -e "$file" ] && echo "file does not exist"
    
  2. 否定测试命令中的测试[ (这是之前大多数答案的方式):

    if [ ! -e "$file" ]; then
        echo "file does not exist"
    fi
    

    要么:

    [ ! -e "$file" ] && echo "file does not exist"
    
  3. 根据测试结果为负( ||而不是&& ):

    只要:

    [ -e "$file" ] || echo "file does not exist"
    

    这看起来很愚蠢(IMO),除非您的代码必须可移植到Bourne shell(如Solaris 10或更早版本的/bin/sh ),而且缺少管道否定运算符( ! ),否则不要使用它:

    if [ -e "$file" ]; then
        :
    else
        echo "file does not exist"
    fi
    

此shell脚本也适用于在目录中查找文件:

echo "enter file"

read -r a

if [ -s /home/trainee02/"$a" ]
then
    echo "yes. file is there."
else
    echo "sorry. file is not there."
fi

要反转测试,请使用“!”。 这相当于其他语言中的“非”逻辑运算符。 试试这个:

if [ ! -f /tmp/foo.txt ];
then
    echo "File not found!"
fi

或以稍微不同的方式书写:

if [ ! -f /tmp/foo.txt ]
    then echo "File not found!"
fi

或者您可以使用:

if ! [ -f /tmp/foo.txt ]
    then echo "File not found!"
fi

或者,将所有人放在一起:

if ! [ -f /tmp/foo.txt ]; then echo "File not found!"; fi

可以写入(使用“和”运算符:&&)作为:

[ ! -f /tmp/foo.txt ] && echo "File not found!"

看起来像这样短:

[ -f /tmp/foo.txt ] || echo "File not found!"

这段代码也有效。

#!/bin/bash
FILE=$1
if [ -f $FILE ]; then
 echo "File '$FILE' Exists"
else
 echo "The File '$FILE' Does Not Exist"
fi

[[ -f $FILE ]] || printf '%s does not exist!\n' "$FILE"

此外,文件可能是破坏的符号链接,或非常规文件,例如套接字,设备或fifo。 例如,要添加对损坏的符号链接的检查:

if [[ ! -f $FILE ]]; then
    if [[ -L $FILE ]]; then
        printf '%s is a broken symlink!\n' "$FILE"
    else
        printf '%s does not exist!\n' "$FILE"
    fi
fi




scripting